<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Mu - apps/mandelbrot-silhouette.mu</title>
<meta name="Generator" content="Vim/8.2">
<meta name="plugin-version" content="vim8.1_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,pre_wrap,no_foldcolumn,expand_tabs,line_ids,prevent_copy=,use_input_for_pc=fallback">
<meta name="colorscheme" content="minimal-light">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #000000; background-color: #ffffd7; }
body { font-size:12pt; font-family: monospace; color: #000000; background-color: #ffffd7; }
a { color:inherit; }
* { font-size:12pt; font-size: 1em; }
.PreProc { color: #c000c0; }
.muRegEdx { color: #af5f00; }
.Special { color: #ff6060; }
.LineNr { }
.muRegEsi { color: #005faf; }
.Constant { color: #008787; }
.muRegEdi { color: #00af00; }
.muRegEcx { color: #870000; }
.Delimiter { color: #c000c0; }
.muFunction { color: #af5f00; text-decoration: underline; }
.muComment { color: #005faf; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<a href='https://github.com/akkartik/mu/blob/main/apps/mandelbrot-silhouette.mu'>https://github.com/akkartik/mu/blob/main/apps/mandelbrot-silhouette.mu</a>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span><span class="muComment"># Mandelbrot set</span>
<span id="L2" class="LineNr">  2 </span><span class="muComment">#</span>
<span id="L3" class="LineNr">  3 </span><span class="muComment"># Install:</span>
<span id="L4" class="LineNr">  4 </span><span class="muComment">#   $ git clone <a href="https://github.com/akkartik/mu">https://github.com/akkartik/mu</a></span>
<span id="L5" class="LineNr">  5 </span><span class="muComment">#   $ cd mu</span>
<span id="L6" class="LineNr">  6 </span><span class="muComment"># Build on Linux:</span>
<span id="L7" class="LineNr">  7 </span><span class="muComment">#   $ ./translate apps/mandelbrot.mu</span>
<span id="L8" class="LineNr">  8 </span><span class="muComment"># Build on other platforms (slow):</span>
<span id="L9" class="LineNr">  9 </span><span class="muComment">#   $ ./translate_emulated apps/mandelbrot.mu</span>
<span id="L10" class="LineNr"> 10 </span><span class="muComment"># Run:</span>
<span id="L11" class="LineNr"> 11 </span><span class="muComment">#   $ qemu-system-i386 code.img</span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot-silhouette.mu.html#L13'>main</a></span> <a href='../500fake-screen.mu.html#L16'>screen</a>: (addr <a href='../500fake-screen.mu.html#L16'>screen</a>), keyboard: (addr keyboard), data-disk: (addr disk) <span class="Delimiter">{</span>
<span id="L14" class="LineNr"> 14 </span>  <a href='mandelbrot-silhouette.mu.html#L17'>mandelbrot</a> <a href='../500fake-screen.mu.html#L16'>screen</a>
<span id="L15" class="LineNr"> 15 </span><span class="Delimiter">}</span>
<span id="L16" class="LineNr"> 16 </span>
<span id="L17" class="LineNr"> 17 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot-silhouette.mu.html#L17'>mandelbrot</a></span> <a href='../500fake-screen.mu.html#L16'>screen</a>: (addr <a href='../500fake-screen.mu.html#L16'>screen</a>) <span class="Delimiter">{</span>
<span id="L18" class="LineNr"> 18 </span>  <span class="PreProc">var</span> a/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L19" class="LineNr"> 19 </span>  <span class="PreProc">var</span> b/<span class="muRegEcx">ecx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L20" class="LineNr"> 20 </span>  a, b <span class="Special">&lt;-</span> <a href='../500fake-screen.mu.html#L75'>screen-size</a> <a href='../500fake-screen.mu.html#L16'>screen</a>
<span id="L21" class="LineNr"> 21 </span>  <span class="PreProc">var</span> width/<span class="muRegEsi">esi</span>: int <span class="Special">&lt;-</span> copy a
<span id="L22" class="LineNr"> 22 </span>  width <span class="Special">&lt;-</span> shift-left <span class="Constant">3</span>/log2-font-width
<span id="L23" class="LineNr"> 23 </span>  <span class="PreProc">var</span> height/<span class="muRegEdi">edi</span>: int <span class="Special">&lt;-</span> copy b
<span id="L24" class="LineNr"> 24 </span>  height <span class="Special">&lt;-</span> shift-left <span class="Constant">4</span>/log2-font-height
<span id="L25" class="LineNr"> 25 </span>  <span class="PreProc">var</span> y/<span class="muRegEcx">ecx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L26" class="LineNr"> 26 </span>  <span class="Delimiter">{</span>
<span id="L27" class="LineNr"> 27 </span>    compare y, height
<span id="L28" class="LineNr"> 28 </span>    <span class="PreProc">break-if-&gt;=</span>
<span id="L29" class="LineNr"> 29 </span>    <span class="PreProc">var</span> imaginary/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> <a href='mandelbrot-silhouette.mu.html#L135'>viewport-to-imaginary</a> y, width, height
<span id="L30" class="LineNr"> 30 </span>    <span class="PreProc">var</span> x/<span class="muRegEdx">edx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L31" class="LineNr"> 31 </span>    <span class="Delimiter">{</span>
<span id="L32" class="LineNr"> 32 </span>      compare x, width
<span id="L33" class="LineNr"> 33 </span>      <span class="PreProc">break-if-&gt;=</span>
<span id="L34" class="LineNr"> 34 </span>      <span class="PreProc">var</span> real/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> <a href='mandelbrot-silhouette.mu.html#L119'>viewport-to-real</a> x, width
<span id="L35" class="LineNr"> 35 </span>      <span class="PreProc">var</span> iterations/eax: int <span class="Special">&lt;-</span> <a href='mandelbrot-silhouette.mu.html#L54'>mandelbrot-iterations-for-point</a> real, imaginary, <span class="Constant">0x400</span>/max
<span id="L36" class="LineNr"> 36 </span>      compare iterations, <span class="Constant">0x400</span>/max
<span id="L37" class="LineNr"> 37 </span>      <span class="Delimiter">{</span>
<span id="L38" class="LineNr"> 38 </span>        <span class="PreProc">break-if-&gt;=</span>
<span id="L39" class="LineNr"> 39 </span>        <a href='../500fake-screen.mu.html#L580'>pixel</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, x, y, <span class="Constant">0xf</span>/white
<span id="L40" class="LineNr"> 40 </span>      <span class="Delimiter">}</span>
<span id="L41" class="LineNr"> 41 </span>      compare iterations, <span class="Constant">0x400</span>/max
<span id="L42" class="LineNr"> 42 </span>      <span class="Delimiter">{</span>
<span id="L43" class="LineNr"> 43 </span>        <span class="PreProc">break-if-&lt;</span>
<span id="L44" class="LineNr"> 44 </span>        <a href='../500fake-screen.mu.html#L580'>pixel</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, x, y, <span class="Constant">0</span>/black
<span id="L45" class="LineNr"> 45 </span>      <span class="Delimiter">}</span>
<span id="L46" class="LineNr"> 46 </span>      x <span class="Special">&lt;-</span> increment
<span id="L47" class="LineNr"> 47 </span>      <span class="PreProc">loop</span>
<span id="L48" class="LineNr"> 48 </span>    <span class="Delimiter">}</span>
<span id="L49" class="LineNr"> 49 </span>    y <span class="Special">&lt;-</span> increment
<span id="L50" class="LineNr"> 50 </span>    <span class="PreProc">loop</span>
<span id="L51" class="LineNr"> 51 </span>  <span class="Delimiter">}</span>
<span id="L52" class="LineNr"> 52 </span><span class="Delimiter">}</span>
<span id="L53" class="LineNr"> 53 </span>
<span id="L54" class="LineNr"> 54 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot-silhouette.mu.html#L54'>mandelbrot-iterations-for-point</a></span> real: float, imaginary: float, max: int<span class="PreProc"> -&gt; </span>_/eax: int <span class="Delimiter">{</span>
<span id="L55" class="LineNr"> 55 </span>  <span class="PreProc">var</span> zero: float
<span id="L56" class="LineNr"> 56 </span>  <span class="PreProc">var</span> x/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> copy zero
<span id="L57" class="LineNr"> 57 </span>  <span class="PreProc">var</span> y/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> copy zero
<span id="L58" class="LineNr"> 58 </span>  <span class="PreProc">var</span> iterations/<span class="muRegEcx">ecx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L59" class="LineNr"> 59 </span>  <span class="Delimiter">{</span>
<span id="L60" class="LineNr"> 60 </span>    <span class="PreProc">var</span> done?/eax: boolean <span class="Special">&lt;-</span> <a href='mandelbrot-silhouette.mu.html#L75'>mandelbrot-done?</a> x, y
<span id="L61" class="LineNr"> 61 </span>    compare done?, <span class="Constant">0</span>/false
<span id="L62" class="LineNr"> 62 </span>    <span class="PreProc">break-if-!=</span>
<span id="L63" class="LineNr"> 63 </span>    compare iterations, max
<span id="L64" class="LineNr"> 64 </span>    <span class="PreProc">break-if-&gt;=</span>
<span id="L65" class="LineNr"> 65 </span>    <span class="PreProc">var</span> newx/<span class="Constant">xmm2</span>: float <span class="Special">&lt;-</span> <a href='mandelbrot-silhouette.mu.html#L93'>mandelbrot-x</a> x, y, real
<span id="L66" class="LineNr"> 66 </span>    <span class="PreProc">var</span> newy/<span class="Constant">xmm3</span>: float <span class="Special">&lt;-</span> <a href='mandelbrot-silhouette.mu.html#L105'>mandelbrot-y</a> x, y, imaginary
<span id="L67" class="LineNr"> 67 </span>    x <span class="Special">&lt;-</span> copy newx
<span id="L68" class="LineNr"> 68 </span>    y <span class="Special">&lt;-</span> copy newy
<span id="L69" class="LineNr"> 69 </span>    iterations <span class="Special">&lt;-</span> increment
<span id="L70" class="LineNr"> 70 </span>    <span class="PreProc">loop</span>
<span id="L71" class="LineNr"> 71 </span>  <span class="Delimiter">}</span>
<span id="L72" class="LineNr"> 72 </span>  <span class="PreProc">return</span> iterations
<span id="L73" class="LineNr"> 73 </span><span class="Delimiter">}</span>
<span id="L74" class="LineNr"> 74 </span>
<span id="L75" class="LineNr"> 75 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot-silhouette.mu.html#L75'>mandelbrot-done?</a></span> x: float, y: float<span class="PreProc"> -&gt; </span>_/eax: boolean <span class="Delimiter">{</span>
<span id="L76" class="LineNr"> 76 </span>  <span class="muComment"># x*x + y*y &gt; 4</span>
<span id="L77" class="LineNr"> 77 </span>  <span class="PreProc">var</span> x2/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> copy x
<span id="L78" class="LineNr"> 78 </span>  x2 <span class="Special">&lt;-</span> multiply x
<span id="L79" class="LineNr"> 79 </span>  <span class="PreProc">var</span> y2/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> copy y
<span id="L80" class="LineNr"> 80 </span>  y2 <span class="Special">&lt;-</span> multiply y
<span id="L81" class="LineNr"> 81 </span>  <span class="PreProc">var</span> sum/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> copy x2
<span id="L82" class="LineNr"> 82 </span>  sum <span class="Special">&lt;-</span> add y2
<span id="L83" class="LineNr"> 83 </span>  <span class="PreProc">var</span> four/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">4</span>
<span id="L84" class="LineNr"> 84 </span>  <span class="PreProc">var</span> four-f/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> convert four
<span id="L85" class="LineNr"> 85 </span>  compare sum, four-f
<span id="L86" class="LineNr"> 86 </span>  <span class="Delimiter">{</span>
<span id="L87" class="LineNr"> 87 </span>    <span class="PreProc">break-if-float&gt;</span>
<span id="L88" class="LineNr"> 88 </span>    <span class="PreProc">return</span> <span class="Constant">0</span>/false
<span id="L89" class="LineNr"> 89 </span>  <span class="Delimiter">}</span>
<span id="L90" class="LineNr"> 90 </span>  <span class="PreProc">return</span> <span class="Constant">1</span>/true
<span id="L91" class="LineNr"> 91 </span><span class="Delimiter">}</span>
<span id="L92" class="LineNr"> 92 </span>
<span id="L93" class="LineNr"> 93 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot-silhouette.mu.html#L93'>mandelbrot-x</a></span> x: float, y: float, real: float<span class="PreProc"> -&gt; </span>_/<span class="Constant">xmm2</span>: float <span class="Delimiter">{</span>
<span id="L94" class="LineNr"> 94 </span>  <span class="muComment"># x*x - y*y + real</span>
<span id="L95" class="LineNr"> 95 </span>  <span class="PreProc">var</span> x2/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> copy x
<span id="L96" class="LineNr"> 96 </span>  x2 <span class="Special">&lt;-</span> multiply x
<span id="L97" class="LineNr"> 97 </span>  <span class="PreProc">var</span> y2/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> copy y
<span id="L98" class="LineNr"> 98 </span>  y2 <span class="Special">&lt;-</span> multiply y
<span id="L99" class="LineNr"> 99 </span>  <span class="PreProc">var</span> result/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> copy x2
<span id="L100" class="LineNr">100 </span>  result <span class="Special">&lt;-</span> subtract y2
<span id="L101" class="LineNr">101 </span>  result <span class="Special">&lt;-</span> add real
<span id="L102" class="LineNr">102 </span>  <span class="PreProc">return</span> result
<span id="L103" class="LineNr">103 </span><span class="Delimiter">}</span>
<span id="L104" class="LineNr">104 </span>
<span id="L105" class="LineNr">105 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot-silhouette.mu.html#L105'>mandelbrot-y</a></span> x: float, y: float, imaginary: float<span class="PreProc"> -&gt; </span>_/<span class="Constant">xmm3</span>: float <span class="Delimiter">{</span>
<span id="L106" class="LineNr">106 </span>  <span class="muComment"># 2*x*y + imaginary</span>
<span id="L107" class="LineNr">107 </span>  <span class="PreProc">var</span> two/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">2</span>
<span id="L108" class="LineNr">108 </span>  <span class="PreProc">var</span> result/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> convert two
<span id="L109" class="LineNr">109 </span>  result <span class="Special">&lt;-</span> multiply x
<span id="L110" class="LineNr">110 </span>  result <span class="Special">&lt;-</span> multiply y
<span id="L111" class="LineNr">111 </span>  result <span class="Special">&lt;-</span> add imaginary
<span id="L112" class="LineNr">112 </span>  <span class="PreProc">return</span> result
<span id="L113" class="LineNr">113 </span><span class="Delimiter">}</span>
<span id="L114" class="LineNr">114 </span>
<span id="L115" class="LineNr">115 </span><span class="muComment"># Scale (x, y) pixel coordinates to a complex plane where the viewport width</span>
<span id="L116" class="LineNr">116 </span><span class="muComment"># ranges from (scene-cx - scene-width/2) to (scene-cx + scene-width/2).</span>
<span id="L117" class="LineNr">117 </span><span class="muComment"># Viewport height just follows the viewport's aspect ratio.</span>
<span id="L118" class="LineNr">118 </span>
<span id="L119" class="LineNr">119 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot-silhouette.mu.html#L119'>viewport-to-real</a></span> x: int, width: int<span class="PreProc"> -&gt; </span>_/<span class="Constant">xmm0</span>: float <span class="Delimiter">{</span>
<span id="L120" class="LineNr">120 </span>  <span class="muComment"># (x - width/2)*4/width</span>
<span id="L121" class="LineNr">121 </span>  <span class="PreProc">var</span> result/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> convert x
<span id="L122" class="LineNr">122 </span>  <span class="PreProc">var</span> width-f/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> convert width
<span id="L123" class="LineNr">123 </span>  <span class="PreProc">var</span> two/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">2</span>
<span id="L124" class="LineNr">124 </span>  <span class="PreProc">var</span> two-f/<span class="Constant">xmm2</span>: float <span class="Special">&lt;-</span> convert two
<span id="L125" class="LineNr">125 </span>  <span class="PreProc">var</span> half-width-f/<span class="Constant">xmm2</span>: float <span class="Special">&lt;-</span> reciprocal two-f
<span id="L126" class="LineNr">126 </span>  half-width-f <span class="Special">&lt;-</span> multiply width-f
<span id="L127" class="LineNr">127 </span>  result <span class="Special">&lt;-</span> subtract half-width-f
<span id="L128" class="LineNr">128 </span>  <span class="PreProc">var</span> four/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">4</span>
<span id="L129" class="LineNr">129 </span>  <span class="PreProc">var</span> four-f/<span class="Constant">xmm2</span>: float <span class="Special">&lt;-</span> convert four
<span id="L130" class="LineNr">130 </span>  result <span class="Special">&lt;-</span> multiply four-f
<span id="L131" class="LineNr">131 </span>  result <span class="Special">&lt;-</span> divide width-f
<span id="L132" class="LineNr">132 </span>  <span class="PreProc">return</span> result
<span id="L133" class="LineNr">133 </span><span class="Delimiter">}</span>
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot-silhouette.mu.html#L135'>viewport-to-imaginary</a></span> y: int, width: int, height: int<span class="PreProc"> -&gt; </span>_/<span class="Constant">xmm1</span>: float <span class="Delimiter">{</span>
<span id="L136" class="LineNr">136 </span>  <span class="muComment"># (y - height/2)*4/width</span>
<span id="L137" class="LineNr">137 </span>  <span class="PreProc">var</span> result/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> convert y
<span id="L138" class="LineNr">138 </span>  <span class="PreProc">var</span> height-f/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> convert height
<span id="L139" class="LineNr">139 </span>  <span class="PreProc">var</span> half-height-f/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> copy height-f
<span id="L140" class="LineNr">140 </span>  <span class="PreProc">var</span> two/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">2</span>
<span id="L141" class="LineNr">141 </span>  <span class="PreProc">var</span> two-f/<span class="Constant">xmm2</span>: float <span class="Special">&lt;-</span> convert two
<span id="L142" class="LineNr">142 </span>  half-height-f <span class="Special">&lt;-</span> divide two-f
<span id="L143" class="LineNr">143 </span>  result <span class="Special">&lt;-</span> subtract half-height-f
<span id="L144" class="LineNr">144 </span>  <span class="PreProc">var</span> four/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">4</span>
<span id="L145" class="LineNr">145 </span>  <span class="PreProc">var</span> four-f/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> convert four
<span id="L146" class="LineNr">146 </span>  result <span class="Special">&lt;-</span> multiply four-f
<span id="L147" class="LineNr">147 </span>  <span class="PreProc">var</span> width-f/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> convert width
<span id="L148" class="LineNr">148 </span>  result <span class="Special">&lt;-</span> divide width-f
<span id="L149" class="LineNr">149 </span>  <span class="PreProc">return</span> result
<span id="L150" class="LineNr">150 </span><span class="Delimiter">}</span>
</pre>
</body>
</html>
<!-- vim: set foldmethod=manual : -->
